program CommisVoyageur;

uses Windows, messages, graphics, sysutils, math;
  
{$R CommisVoyageur.res}

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      //    
      b1x=9;    
      b1y=7;    
      b1w=55;   
      b1h=25;   
      //save     //time
      b2x=72;    l2x=9;     
      b2y=7;     l2y=140;
      b2w=55;    l2w=131;
      b2h=25;    l2h=26;
      // solve   //nodes     //dist
      b3x=9;     e3x=56;    l3x=9;   
      b3y=105;   e3y=44;    l3y=180;
      b3w=55;    e3w=71;    l3w=131;
      b3h=25;    e3h=15;    l3h=26;
      // generate            //Nodes
      b4x=9;                l4x=9;   
      b4y=72;               l4y=44;
      b4w=55;               l4w=45;  
      b4h=25;               l4h=15;  

      radius = 3; // 

type
 node = record
  x,y:extended;
  i,j:cardinal; // x y  
  dist:extended; //   
 end;

 trgb = record  //     ,     
  b,g,r: byte;
 end;
 ARGB = array [0..399] of TRGB;
 PARGB = ^ARGB;
 
 inar = array of integer;

 tagOFNA = packed record
  lStructSize: DWORD;
  hWndOwner: HWND;
  hInstance: HINST;
  lpstrFilter: PAnsiChar;
  lpstrCustomFilter: PAnsiChar;
  nMaxCustFilter: DWORD;
  nFilterIndex: DWORD;
  lpstrFile: PAnsiChar;
  nMaxFile: DWORD;
  lpstrFileTitle: PAnsiChar;
  nMaxFileTitle: DWORD;
  lpstrInitialDir: PAnsiChar;
  lpstrTitle: PAnsiChar;
  Flags: DWORD;
  nFileOffset: Word;
  nFileExtension: Word;
  lpstrDefExt: PAnsiChar;
  lCustData: LPARAM;
  lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
  lpTemplateName: PAnsiChar;
 end;

function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';
function GetSaveFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetSaveFileNameA';

var
  MainWND: thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg: TMsg;
  but1,but2,but3,but4,ed3,l2,l3,l4: THandle;
  sour: tbitmap; //,  
  ps: array of PARGB;  //      
  grt: trect;   // Graphic RecT
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;
  Sum:extended; //   
  mas: array of node;  //  
  N:integer;           //     
  IsSolved,Running:boolean;
  t1,t2,t3:int64;
  CS: inar;

procedure CalcProc;
 var i,j,l,k:integer;
 x,y,x1,y1,max,min,z,f:extended;
 Ind: inar;
begin
 queryperformancecounter(t1);
 Sum:=0;
 setlength(Ind,N); //       
 for i:=0 to N-1 do Ind[i]:=i;
 setlength(CS,N); //     
 CS[0]:=0;    //        -   
 CS[1]:=N-1;
 x:=mas[0].x-mas[N-1].x;
 y:=mas[0].y-mas[N-1].y;
 mas[N-1].dist:=sqrt(x*x+y*y);
 k:=1; //    
 if N>2 then repeat   //         
  max:=0;
  l:=-1;
  for i:=1 to N-2 do begin  //  ,   ..    
   if Ind[i]=-1 then continue; //      -   
   min:=infinity; //      
   for j:=0 to k do begin
    x1:=mas[i].x-mas[CS[j]].x;  //       
    y1:=mas[i].y-mas[CS[j]].y;
    z:=sqrt(x1*x1+y1*y1);         
    if z<min then min:=z;
   end;
   if min>max then begin //     
    max:=min;
    l:=i;
   end;
  end;
  Ind[l]:=-1; // ,   

  min:=infinity;
  j:=-1;
  f:=0;
  z:=0;
  for i:=1 to k do begin // ,         
   x:=mas[CS[i-1]].x-mas[l].x;
   y:=mas[CS[i-1]].y-mas[l].y;
   x1:=sqrt(x*x+y*y);

   x:=mas[CS[i]].x-mas[l].x;
   y:=mas[CS[i]].y-mas[l].y;
   y1:=sqrt(x*x+y*y);

   x:=x1+y1-mas[CS[i]].dist;
   if x<min then begin
    min:=x;
    j:=i;   //  ,     (   )
    f:=x1;
    z:=y1;
   end;
  end;

  inc(k);
  for i:=k downto j do CS[i]:=CS[i-1];// ,      
  CS[j]:=l;//  . CS    Ind, ..   mas
  mas[CS[j]].dist:=f;
  mas[CS[j+1]].dist:=z;
 until k=N-1;
 queryperformancecounter(t2);
 
 for i:=0 to N-2 do begin
  sour.Canvas.MoveTo(mas[CS[i]].i, mas[CS[i]].j);
  sour.Canvas.LineTo(mas[CS[i+1]].i, mas[CS[i+1]].j);
  sum:=sum+mas[i+1].dist;
 end;
 setwindowtext(l2,pchar('Factual time (seconds): '+floattostr((t2-t1)/t3))); // ,  
 setwindowtext(l3,pchar('Best distance: '+floattostr(Sum)));
 sendmessage(mainwnd,WM_PAINT,0,0);
 enablewindow(but1,true);
 enablewindow(but2,true);
 enablewindow(but3,true);
 enablewindow(but4,true);
 enablewindow(ed3,true);
 setwindowtext(mainwnd,' Commis Voyageur');
 IsSolved:=true;
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

function GetCaption(wnd:Thandle):string;
begin
 setlength(result,255);
 setlength(result,getwindowtext(wnd,pchar(result),255));
end;

procedure bres_circle(xc,yc,radius:integer; r,g,b:byte); // Bresenham's (Pitteway and van Aken) algorithm
 var a,c,d:integer;
 procedure sim(x,y:integer; r,g,b:byte);
  var i,j:integer;
 begin
  i:=xc+x;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc+y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
 end;
begin
 a:=0;
 c:=radius;
 d:=3-2*c;
 while(a<=c) do begin
  sim(a,c,r,g,b);
  if d<0 then d:=d+4*a+8
  else begin
   d:=d+4*(a-c)+10;
   dec(c);
  end;
  inc(a)
 end;
end;

procedure DrawNodes;
 var i:integer;
 R:trect;
begin
 r:=sour.Canvas.ClipRect;
 sour.Canvas.FillRect(R);
 if mas<>nil then begin
  bres_circle(mas[0].i,mas[0].j,radius,0,0,0);
  sour.Canvas.Brush.Color:=clred;
  FloodFill(sour.Canvas.Handle,mas[0].i,mas[0].j,clblack);

  bres_circle(mas[N-1].i,mas[N-1].j,radius,0,0,0);
  sour.Canvas.Brush.Color:=clblue;
  FloodFill(sour.Canvas.Handle,mas[N-1].i,mas[N-1].j,clblack);  

  sour.Canvas.Brush.Color:=clwhite;  
  for i:=1 to N-2 do begin
   bres_circle(mas[i].i,mas[i].j,radius,0,0,0);
  end;
 end; 
 if IsSolved then
  for i:=0 to N-2 do begin
   sour.Canvas.MoveTo(mas[CS[i]].i, mas[CS[i]].j);
   sour.Canvas.LineTo(mas[CS[i+1]].i, mas[CS[i+1]].j);
  end;
 sendmessage(mainwnd,WM_PAINT,0,0);
end;

procedure OpenFil;
 var s,FileBuf,filename:string;
     i:integer;
     f:TextFile;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Two-dimensional array (*.txt)'+#0+'*.txt'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Load two-dimensional array';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetOpenFileName(ofn) then begin
  filename:=ofn.lpstrFile;
  AssignFile(f, FileName);
  Reset(f);
  mas:=nil;
  s:='';
  N:=0;
  try
   while eof(f)=false do begin
    readln(f,s);
    if s<>'' then begin
     inc(N);
     setlength(mas,N);
     i:=pos(' ',s);
     mas[N-1].x:=strtofloat(copy(s,1,i));
     mas[N-1].y:=strtofloat(copy(s,i+1,length(s)-i));
     mas[N-1].i:=doedin(mas[N-1].x*sour.Width);
     mas[N-1].j:=doedin(mas[N-1].y*sour.Width);
    end;
   end;
  finally
   CloseFile(f);
  end;
  if mas<>nil then begin
   enablewindow(but2,true);  //   
   enablewindow(but3,true);
   IsSolved:=false;
   DrawNodes;
   setwindowtext(l2,'Factual time (seconds):'+#10+#13+'0');
   setwindowtext(l3,'Best distance:'+#10+#13+'0');
   SetWindowText(ed3,pchar(inttostr(N)));
  end;
 end;
end;

procedure SaveFil;
 var s,filname,FileBuf:string;
 i:integer;
 f:TextFile;
begin
 FileBuf:=StringOfChar(#0, 26000);
 ofn.hWndOwner:=MainWnd;
 ofn.lpstrFilter:='Two-dimensional array (*.txt)'+#0+'*.txt'+#0+#0;;
 ofn.nFilterIndex:=oFilterIndex;
 ofn.lpstrFile:=PChar(FileBuf);
 ofn.nMaxFile:=Length(FileBuf);
 ofn.lpstrInitialDir:=nil;
 ofn.lpstrTitle:='Save two-dimensional array';
 ofn.Flags:=OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
 ofn.lStructSize:=SizeOf(ofn);
 if GetSaveFileName(ofn) then begin
  filname:=ChangeFileExt(ofn.lpstrFile,'')+'.txt';
  AssignFile(f,filname);
  Rewrite(f);
  try
   for i:=0 to N-1 do begin
    s:=floattostr(mas[i].x)+' '+floattostr(mas[i].y);
    WriteLn(f,s);
   end;
  finally
   CloseFile(f);
  end;
 end;
end;

procedure Generate;
 var i:integer;
 s:string;
begin
 s:=GetCaption(ed3);
 if s='' then begin messagebox(mainwnd,'     Enter a valid quantity.','Error!',mb_ok or mb_iconerror); exit; end;
 N:=strtoint(s);
 if N=0  then begin messagebox(mainwnd,'     Enter a valid quantity.','Error!',mb_ok or mb_iconerror); exit; end;
 setlength(mas,N);
 randomize;
 for i:=0 to N-1 do begin
  mas[i].x:=doedin(1000000*(radius*2/sour.Width+(random*(sour.Width-radius*4)/sour.Width)))/1000000;
  mas[i].y:=doedin(1000000*(radius*2/sour.Width+(random*(sour.Width-radius*4)/sour.Width)))/1000000;
  mas[i].i:=doedin(mas[i].x*sour.Width);
  mas[i].j:=doedin(mas[i].y*sour.Width);
 end;
 IsSolved:=false;
 DrawNodes;
 enablewindow(but2,true);      //   
 enablewindow(but3,true);
 setwindowtext(l2,'Factual time (seconds):'+#10+#13+'0');
 setwindowtext(l3,'Best distance:'+#10+#13+'0');
end;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
 var PST:PAINTSTRUCT;
     d1:hdc;
     i:integer;
     R:trect;
begin
  Result:=0;
  case Msg of
   WM_COMMAND:if HIWORD(wParam)=BN_CLICKED then begin
     if cardinal(lparam)=but1 then OpenFil;  // Load

     if cardinal(lparam)=but2 then SaveFil;  // Save

     if cardinal(lparam)=but3 then if N>1 then begin     // SOLVE
      enablewindow(but1,false);
      enablewindow(but2,false);
      enablewindow(but3,false);
      enablewindow(but4,false);
      enablewindow(ed3,false);
      setwindowtext(mainwnd,' Commis Voyageur - executing, please wait...');
      setwindowtext(l2,'Factual time (seconds):'+#10+#13+'executing...');
      setwindowtext(l3,'Best distance:'+#10+#13+'executing...');
      CreateThread(nil,0,@CalcProc,nil,0,Thr);  //  
      SetThreadPriority(Thr,THREAD_PRIORITY_TIME_CRITICAL); // ,     
     end;

     if cardinal(lparam)=but4 then Generate;       // generate

   end else Result:=DefWindowProc(Wnd, Msg, wParam, lParam);

   WM_CREATE: begin
    But1:=CreateWindow('BUTTON', 'Load', WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,b1x,b1y,b1w,b1h,Wnd,0,hInstance,nil);
    SendMessage(But1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But2:=CreateWindow('BUTTON','Save',WS_CHILD or WS_DISABLED
     or WS_VISIBLE or BS_PUSHLIKE,b2x,b2y,b2w,b2h,Wnd,0,hInstance,nil);
    SendMessage(But2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But3:=CreateWindow('BUTTON','SOLVE',WS_CHILD or WS_DISABLED
     or WS_VISIBLE or BS_PUSHLIKE,b3x,b3y,b3w,b3h,Wnd,0,hInstance,nil);
    SendMessage(But3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But4:=CreateWindow('BUTTON','Generate',WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,b4x,b4y,b4w,b4h,Wnd,0,hInstance,nil);
    SendMessage(But4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed3:=CreateWindow('EDIT','500',WS_CHILD or ES_NUMBER         //  
     or WS_VISIBLE,e3x,e3y,e3w,e3h,Wnd,0,hInstance,nil);
    SendMessage(ed3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l2:=CreateWindow('STATIC','Factual time (seconds):'+#10+#13+'0',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l2x,l2y,l2w,l2h,Wnd,0,hInstance,nil);
    SendMessage(l2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l3:=CreateWindow('STATIC','Best distance:'+#10+#13+'0',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l3x,l3y,l3w,l3h,Wnd,0,hInstance,nil);
    SendMessage(l3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l4:=CreateWindow('STATIC','Nodes =',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l4x,l4y,l4w,l4h,Wnd,0,hInstance,nil);
    SendMessage(l4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    SetFocus(But1);
    result:=0;
   end;

   WM_DESTROY:begin
    DeleteObject(hFontBold);
    unregisterclass('CommVoyagKlass',hinstance);
    postquitmessage(0);
   end;

   WM_SIZE: begin
    if Running then begin
     GetClientRect(mainwnd,R);

     if (r.Left+r.Top+r.Right+r.Bottom)<>0 then
     if (r.Right-140)<r.Bottom then begin
      sour.Width:=R.Right-R.Left-149;
      sour.Height:=sour.Width;
     end else begin
      sour.Height:=R.Bottom-R.Top-10;
      sour.Width:=sour.Height;  
     end;
   
     setlength(ps,sour.Height);  //     
     for i:=0 to High(ps) do ps[i]:=sour.scanline[i];
     if mas<>nil then begin
      for i:=0 to N-1 do begin
       mas[i].i:=doedin(mas[i].x*sour.Width);
       mas[i].j:=doedin(mas[i].y*sour.Width);
      end;
     end;
     DrawNodes;
    end;
    result:=0;     
   end;

   WM_PAINT: begin
    GetClientRect(mainwnd,R);
    r.Left:=r.Left+140;
    InvalidateRect(mainwnd,@R,true);
    BeginPaint(wnd,pst);
    d1:=getdc(mainwnd);
    bitblt(d1,140,5,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy);
    releasedc(mainwnd,d1);
    Endpaint(wnd,pst);
    result:=0;
   end;

   WM_GETMINMAXINFO: begin
     PMinMaxInfo(LParam)^.ptMinTrackSize.X := 414; //    
     PMinMaxInfo(LParam)^.ptMinTrackSize.Y := 295; //    
     result:=0;
   end;                   

  else
   Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
  end;
end;

BEGIN
 queryperformancefrequency(t3);
 Running:=false;
 hFontBold:=CreateFont(8,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');
 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 WC.lpszClassName:='CommVoyagKlass';
 RegisterClass(WC);
 systemparametersinfo(spi_getworkarea, 0, @grt, 0);
 MainWND:=CreateWindow('CommVoyagKlass',' Commis Voyageur',WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_SIZEBOX,
       (grt.Right-grt.Left-824) div 2,5,744,625,0,0,hInstance, nil);

 sour:=tbitmap.Create;
 sour.PixelFormat:=pf24bit;
 IsSolved:=false;
 Running:=true;
 sendmessage(mainwnd,WM_SIZE,0,0);

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
